using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.Xml.XPath;
using System.Text;

namespace StarChat
{
	/// <summary>
	/// Summary description for Main.
	/// </summary>
	public class OneMain : System.Web.UI.Page
	{
	
		public string chatFileNo;
		string new_room,name,id,age,sex,avata;
		public string order;
		protected System.Web.UI.WebControls.Label message;
		protected System.Web.UI.WebControls.Label input;
		protected System.Web.UI.WebControls.ImageButton ImageButton1;
		protected System.Web.UI.WebControls.Image Image1;
		string curTotalLine;

		public OneMain()
		{
			Page.Init += new System.EventHandler(Page_Init);
		}

		private void Page_UnLoad(object sender, System.EventArgs e)
		{
			//Del_User();
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			new_room = Request.QueryString["new_room"];
			chatFileNo =Request.QueryString["roomNo"];
			name = Session["name"].ToString();
			age = Session["age"].ToString();
			id = Session["id"].ToString();
			sex = Session["sex"].ToString();
			avata = Session["avata"].ToString();

			Session["roomNo"] = chatFileNo;

			order = Request.QueryString["order"];
			curTotalLine=1;

			if(!Page.IsPostBack)
			{
    
				if(new_room=="0")
				{
						Join_Room();
				}
				else
				{
					try
					{
						Enter_Room();
						Add_Participants();
			
					}
					catch(Exception ex)
					{
						Response.Write("Error");
					}
				}
				
				message.Text ="<iframe id='messageFrame' width='370' height='400' frameborder='no' src='OnetooneMessage.htm?"+chatFileNo+"&"+name+"&"+curTotalLine+"' scrolling='auto'></iframe>";
				input.Text ="<iframe id='inputFrame' width='310' height='50' frameborder='no' src='OnetooneInput.aspx?roomNo="+chatFileNo+"&name="+name+"&id="+id+"&avata="+avata+"' scrolling='no'></iframe>";

			}
		}

		private void Page_Init(object sender, EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
		}

		#region Web Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.ImageButton1.Click += new System.Web.UI.ImageClickEventHandler(this.ImageButton1_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion


		protected void Join_Room()
		{
			XmlDocument Document1 = new XmlDocument();
			string chatFile = "/StarChat/Onetoonedata/chat"+chatFileNo+".xml";
			XmlTextReader Reader1 = new XmlTextReader (Server.MapPath(chatFile));
			Document1.Load (Reader1);  
			Reader1.Close();      
  
			XmlNode CurNode1 = Document1.DocumentElement.ChildNodes[0];
			int totalLine = Int32.Parse(CurNode1.InnerText)+1;
			CurNode1.InnerText=totalLine.ToString();
			XmlNode CurNode2 = Document1.DocumentElement.ChildNodes[2];
			XmlDocumentFragment NewData1 = Document1.CreateDocumentFragment();
			NewData1.InnerXml=("\n\t<name>"+name+"</name>\n"+"<id>"+id+"</id>\n"+"<age>"+age+"</age>\n"+"<sex>"+sex+"</sex>\n"+"<avata>"+avata+"</avata>\n");

			CurNode2.InsertAfter(NewData1, CurNode2.LastChild);
			XmlNode CurNode3 =  Document1.DocumentElement.ChildNodes[3];
			XmlDocumentFragment NewData2 = Document1.CreateDocumentFragment();
			NewData2.InnerXml=("\n\t\t<message from='' to='' no='"+totalLine+"'>&lt;center&gt;&lt;font color='blue'&gt;"+id+" ̽ϴ.&lt;/font&gt;&lt;/center&gt;</message>\n");
			CurNode3.InsertAfter(NewData2, CurNode3.LastChild);

			Document1.Save(Server.MapPath(chatFile));
			curTotalLine=(totalLine-1).ToString();
		}


		protected void Enter_Room()
		{
			XmlDocument Document1 = new XmlDocument();
			string chatFile = "/StarChat/Onetoonedata/chat"+chatFileNo+".xml";
			XmlTextReader Reader1 = new XmlTextReader (Server.MapPath(chatFile));
			Document1.Load (Reader1);  
			Reader1.Close();      
  
			XmlNodeList nameList = Document1.SelectNodes("chatroom/participants/name");
  
			int outIndex=0;
			while(outIndex==0)
			{
				foreach(XmlNode nameNode in nameList)
				{
					if(nameNode.InnerText == name)
					{
						name = name+"1";
					}
					else
					{
						outIndex=1;
					}
				}
			}
  
			XmlNode CurNode1 = Document1.DocumentElement.ChildNodes[0];
			int totalLine = Int32.Parse(CurNode1.InnerText)+1;
			CurNode1.InnerText=totalLine.ToString();
			XmlNode CurNode2 = Document1.DocumentElement.ChildNodes[2];
			XmlDocumentFragment NewData1 = Document1.CreateDocumentFragment();
			NewData1.InnerXml=("\n\t<name>"+name+"</name>\n"+"<id>"+id+"</id>\n"+"<age>"+age+"</age>\n"+"<sex>"+sex+"</sex>\n"+"<avata>"+avata+"</avata>\n");

			CurNode2.InsertAfter(NewData1, CurNode2.LastChild);
			XmlNode CurNode3 =  Document1.DocumentElement.ChildNodes[3];
			XmlDocumentFragment NewData2 = Document1.CreateDocumentFragment();
			NewData2.InnerXml=("\n\t\t<message from='' to='' no='"+totalLine+"'>&lt;center&gt;&lt;font color='blue'&gt;"+name+" ̽ϴ.&lt;/font&gt;&lt;/center&gt;</message>\n");
			CurNode3.InsertAfter(NewData2, CurNode3.LastChild);

			Document1.Save(Server.MapPath(chatFile));
			curTotalLine=(totalLine-1).ToString();
		}

		protected void Add_Participants()
		{
			XmlDocument Document1 = new XmlDocument();
			string chatFile = "/StarChat/OnetooneData/chatlist.xml";
			XmlTextReader Reader1 = new XmlTextReader (Server.MapPath(chatFile));
			Document1.Load (Reader1);  
			Reader1.Close();          
			XmlNode CurNode1 = Document1.DocumentElement.ChildNodes[Int32.Parse(order)+1];
			CurNode1.ChildNodes[4].InnerText = (Int32.Parse(CurNode1.ChildNodes[4].InnerText)+1).ToString();
        
			Document1.Save(Server.MapPath(chatFile));
		}



		private void ImageButton1_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{

			Del_User();

			Response.Write("<script language='javascript' >window.close();</script>");	
		}

		public void Del_User()
		{
			try
			{
				XmlDocument Document1 = new XmlDocument();
				string chatFile = "/StarChat/Onetoonedata/chat"+chatFileNo+".xml";
				XmlTextReader Reader1 = new XmlTextReader (Server.MapPath(chatFile));
				Document1.Load (Reader1);  
				Reader1.Close();
				XmlNodeList CurNodeList1 = Document1.SelectNodes("chatroom/participants/name");
				XmlNodeList CurNodeList2 = Document1.SelectNodes("chatroom/participants/id");
				XmlNodeList CurNodeList3 = Document1.SelectNodes("chatroom/participants/age");
				XmlNodeList CurNodeList4 = Document1.SelectNodes("chatroom/participants/sex");
				XmlNodeList CurNodeList5 = Document1.SelectNodes("chatroom/participants/avata");
				int max = CurNodeList1.Count;

				if(max==1)
				{
					Remove_Room();
				}
				else
				{
					for(int i=0;i<max;i++)
					{
						if(CurNodeList2.Item(i).InnerText==id)
						{
							Document1.DocumentElement.ChildNodes[2].RemoveChild(CurNodeList1.Item(i));
							Document1.DocumentElement.ChildNodes[2].RemoveChild(CurNodeList2.Item(i));
							Document1.DocumentElement.ChildNodes[2].RemoveChild(CurNodeList3.Item(i));
							Document1.DocumentElement.ChildNodes[2].RemoveChild(CurNodeList4.Item(i));
							Document1.DocumentElement.ChildNodes[2].RemoveChild(CurNodeList5.Item(i));
						}
					}
      
					XmlNode CurNode1 = Document1.DocumentElement.ChildNodes[0];
					int totalLine = Int32.Parse(CurNode1.InnerText)+1;
					CurNode1.InnerText=totalLine.ToString(); 
					XmlNode CurNode2 =  Document1.DocumentElement.ChildNodes[3];
					XmlDocumentFragment NewData1 = Document1.CreateDocumentFragment();
					NewData1.InnerXml=("\n\t\t<message from='' to='' no='"+totalLine+"'>&lt;center&gt;&lt;font color='blue'&gt;"+name+" ̽ϴ.&lt;/font&gt;&lt;/center&gt;</message>\n");
					CurNode2.InsertAfter(NewData1, CurNode2.LastChild);
      
					Document1.Save(Server.MapPath(chatFile));
					Del_Participants();
				}
    
    
			}
			catch(Exception ex)
			{ 
			}

		}

		protected void Remove_Room()
		{
			XmlDocument Document1 = new XmlDocument();
			string chatFile = "/StarChat/Onetoonedata/chatlist.xml";
			XmlTextReader Reader1 = new XmlTextReader (Server.MapPath(chatFile));
			Document1.Load (Reader1);  
			Reader1.Close();
			XmlNode CurNode1 = Document1.DocumentElement.ChildNodes[0];
			CurNode1.InnerText = (Int32.Parse(CurNode1.InnerText)-1).ToString();
			XmlNode CurNode2 = Document1.DocumentElement.ChildNodes[Int32.Parse(order)-1];
			Document1.DocumentElement.RemoveChild(CurNode2);
			Document1.Save(Server.MapPath(chatFile));
		}


		protected void Del_Participants()
		{
			XmlDocument Document1 = new XmlDocument();
			string chatFile = "/StarChat/Onetoonedata/chatlist.xml";
			XmlTextReader Reader1 = new XmlTextReader (Server.MapPath(chatFile));
			Document1.Load (Reader1);  
			Reader1.Close();          
			XmlNode CurNode1 = Document1.DocumentElement.ChildNodes[Int32.Parse(order)+1];
			CurNode1.ChildNodes[4].InnerText = (Int32.Parse(CurNode1.ChildNodes[4].InnerText)-1).ToString();
        
			Document1.Save(Server.MapPath(chatFile));
		}


	}
}
